from aiogram import types
from aiogram.dispatcher.filters.builtin import CommandStart
from data.config import load_config
from filters.all_filters import IsPrivate
from keyboards.default.admin_keyboard import start_menu
from keyboards.default.user_keyboard import next_page
from states.all_states import AllPages
from utils.other_functions import *
from datetime import datetime


@dp.message_handler(IsPrivate(), text='Начать', state='*')
@dp.message_handler(CommandStart(), state='*')
async def bot_start(message: types.message):
    start_command = message.text
    referral_id = str(start_command[7:])
    if referral_id == "":
        referral_id = 0
    user_name = message.from_user.first_name
    user_login = message.from_user.username
    get_user_id = get_user(user_id=message.from_user.id)
    if get_user_id is None:
        if str(referral_id) != str(message.from_user.id):
            add_user(message.from_user.id, user_login, user_name,
                     datetime.now().strftime("%d.%m.%Y %H:%M:%S"), int(referral_id), 0)
            config = load_config()
            if message.from_user.id not in config.tg_bot.admin_ids:
                for admin_id in config.tg_bot.admin_ids:
                    try:
                        await dp.bot.send_message(admin_id,
                                                  text=f'<b>🔥 Новый пользователь: {message.from_user.id} (@{user_login})</b>')
                    except:
                        pass
            try:
                await dp.bot.send_message(referral_id,
                                          text='<b>✅ По вашей ссылке присоединился новый человек!</b>')
                update_user(user_id=referral_id,
                            number_of_referrals=get_user(user_id=referral_id)['number_of_referrals'] + 1)
            except:
                pass
    else:
        if user_name != get_user_id['user_name']:
            update_user(get_user_id['user_id'], user_name=user_name)
        if user_login is not None:
            if user_login.lower() != get_user_id['user_login']:
                update_user(get_user_id['user_id'], user_login=user_login.lower())
    photo = open(f'first_bot/images/photo_1.jpg', 'rb')
    flag = await check_admin(message.from_user.id)
    if flag:
        await dp.bot.send_photo(message.from_user.id, photo,
                                f"👋<b>Привет, <a href='tg://user?id={message.from_user.id}'>{user_name}</a>\n\nВ честь появления Рrеmium мы устраиваем глобальную paздaчy для всех желающих! Успей и ты получить свой пoдapoк!</b>",
                                reply_markup=start_menu())
    else:
        await dp.bot.send_photo(message.from_user.id, photo,
                                f"👋<b>Привет, <a href='tg://user?id={message.from_user.id}'>{user_name}</a>\n\nВ честь появления Рrеmium мы устраиваем глобальную paздaчy для всех желающих! Успей и ты получить свой пoдapoк!</b>",
                                reply_markup=next_page())
    await AllPages.page_1.set()
