from aiogram.types import InlineKeyboardMarkup, InlineKeyboardButton

from data.config import load_config


def links_to_channels():
    config = load_config()
    links_to_channels_menu = InlineKeyboardMarkup()
    count = 1
    for channel_link in config.tg_bot.channels_links:
        links_to_channels_menu.add(InlineKeyboardButton(text=f"🖥Подписаться - {count}", url=channel_link.strip()))
        count += 1
    links_to_channels_menu.add(InlineKeyboardButton(text=f"✅Я подписался", callback_data='check_subscribe'))
    return links_to_channels_menu


def load_bot_statistics():
    config = load_config()
    bot_statistics_keyboard = InlineKeyboardMarkup()
    bot_statistics_keyboard.add(InlineKeyboardButton(text=f"💳 Купить рекламу", url=f'tg://user?id={config.tg_bot.admin_ids[0]}'))
    bot_statistics_keyboard.add(InlineKeyboardButton(text=f"💎 Купить Premium", url=f'https://t.me/123'))
    bot_statistics_keyboard.add(InlineKeyboardButton(text=f"📢 Канал проекта", url=config.tg_bot.channels_links[0]))
    return bot_statistics_keyboard


def load_advertising_url(url):
    advertising_url_button = InlineKeyboardMarkup()
    advertising_url_button.add(InlineKeyboardButton(text=f"📢 Проверенный проект", url=url))
    return advertising_url_button
