from aiogram import executor
from handlers import dp
import filters
from loader import scheduler
from utils.set_bot_commands import set_default_commands
from utils.db_api.api_sqlite import create_bdx
from utils.other_functions import update_bot_stat


async def scheduler_start():
    scheduler.add_job(update_bot_stat, "interval", seconds=3600)


async def on_startup(dp):
    await set_default_commands(dp)
    filters.setup(dp)
    await scheduler_start()
    print('Бот запущен')


if __name__ == '__main__':
    create_bdx()
    scheduler.start()
    executor.start_polling(dp, on_startup=on_startup)
