import datetime
from data.config import load_config
from loader import dp
from random import randint
from utils.db_api.api_sqlite import *


async def check_admin(user_id):
    config = load_config()
    flag = False
    for admin in config.tg_bot.admin_ids:
        if str(admin) == str(user_id):
            flag = True
    return flag


async def generate_stats():
    users = get_all_users()
    count_all_users = len(users)
    count_users_day = 0
    count_users_week = 0
    count_users_month = 0
    now_time = datetime.datetime.now()
    referrals = []
    for user in users:
        registration_date = datetime.datetime.strptime(user['registration_date'], '%d.%m.%Y %H:%M:%S')
        one_day = f'{datetime.datetime.now().strftime("%d.%m.%Y")} 00:00:00'
        one_day = datetime.datetime.strptime(one_day, '%d.%m.%Y %H:%M:%S')
        one_week = datetime.timedelta(7)
        one_month = datetime.timedelta(30)
        if one_day <= registration_date:
            count_users_day += 1
        if now_time - one_week <= registration_date:
            count_users_week += 1
        if now_time - one_month <= registration_date:
            count_users_month += 1
        referrals.append((user['number_of_referrals'], user['user_id'], f"@{user['user_login']}"))
    referrals = sorted(referrals, reverse=True)
    text_stat = f'💼<b> Меню администратора</b>\n\n' \
                f'👥 Пользователей всего: {count_all_users}\n' \
                f'👤 За месяц: {count_users_month}\n' \
                f'👤 За неделю: {count_users_week}\n' \
                f'👤 За день: {count_users_day}\n\n' \
                f'👥<b> Топ по рефералам</b>\n'
    count_referral = 0
    for referral in referrals:
        text_stat += f'{referral[1]} | {referral[0]} ({referral[2]})\n'
        count_referral += 1
        if count_referral == 10:
            break
    return text_stat


async def send_a_newsletter(text, type_send, photo, video):
    config = load_config()
    users = get_all_users()
    count = 0
    for user in users:
        if user['user_id'] not in config.tg_bot.admin_ids:
            try:
                if type_send == 'text':
                    await dp.bot.send_message(user['user_id'], text=text)
                elif type_send == 'photo':
                    await dp.bot.send_photo(user['user_id'], photo=photo['photo'], caption=text)
                elif type_send == 'video':
                    await dp.bot.send_video(user['user_id'], video=video['video'], caption=text)
                count += 1
            except:
                pass
    return count


async def update_bot_stat():
    info_stat = get_stat()
    count_fake_users = info_stat['count_fake_users'] + randint(30, 40)
    count_fake_premium = info_stat['count_fake_premium'] + randint(10, 20)
    update_stat(count_fake_users=count_fake_users, count_fake_premium=count_fake_premium)
