from aiogram import types
from aiogram.dispatcher.filters import BoundFilter
from keyboards.inline.channels_inline import links_to_channels
from loader import dp
from data.config import load_config


# Проверка на написания сообщения в ЛС бота
class IsPrivate(BoundFilter):
    async def check(self, message: types.Message):
        return message.chat.type == types.ChatType.PRIVATE


# Проверка на админа
class IsAdmin(BoundFilter):
    async def check(self, message: types.Message):
        config = load_config()
        flag = False
        for admin in config.tg_bot.admin_ids:
            if str(admin) == str(message.from_user.id):
                flag = True
        return flag


# Проверка подписки
class IsSubscriber(BoundFilter):
    async def check(self, message: types.Message):
        config = load_config()
        subscribed = 0
        for channel_id in config.tg_bot.channels_ids:
            channel_id = int(str(channel_id).strip())
            sub = await dp.bot.get_chat_member(chat_id=channel_id, user_id=message.from_user.id)
            if sub.status != types.ChatMemberStatus.LEFT:
                subscribed += 1
            else:
                break
        if subscribed == len(config.tg_bot.channels_ids):
            return True
        else:
            await dp.bot.send_message(message.from_user.id,
                                      f"<b>⭐Для получения премиума подпишитесь на наших спонсоров, которые помогают нам с раздачей:</b>",
                                      reply_markup=links_to_channels())
            return False
