from aiogram import types
from aiogram.dispatcher import FSMContext

from filters.all_filters import IsPrivate, IsAdmin
from keyboards.default.admin_keyboard import back_button, start_menu, confirm_menu
from states.all_states import AllPages, MailingMenu
from utils.other_functions import *


@dp.message_handler(IsPrivate(), IsAdmin(), text='💼 Меню администратора', state=AllPages.page_1)
async def open_stats(message: types.message):
    text_stat = await generate_stats()
    await dp.bot.send_message(message.from_user.id, text=text_stat)


@dp.message_handler(IsPrivate(), IsAdmin(), text='📢Рассылка', state=AllPages.page_1)
async def make_a_newsletter(message: types.message):
    await dp.bot.send_message(message.from_user.id,
                              text='<b>📢Рассылка</b>\n\nЧтобы сделать рассылку введите любое сообщение!',
                              reply_markup=back_button())
    await MailingMenu.get_message.set()


@dp.message_handler(IsPrivate(), IsAdmin(), text=['◀Назад', '❌Отмена'],
                    state=[MailingMenu.get_message, MailingMenu.confirm_menu_state])
async def return_main_menu(message: types.message):
    await dp.bot.send_message(message.from_user.id,
                              text=f'<b>❌Рассылка отменена</b>')
    await dp.bot.send_message(message.from_user.id, '<b>Выберите кнопку для продолжения</b>', reply_markup=start_menu())
    await AllPages.page_1.set()


@dp.message_handler(IsPrivate(), IsAdmin(), state=MailingMenu.get_message)
async def open_the_confirmation_menu(message: types.message, state: FSMContext):
    await dp.bot.send_message(message.from_user.id,
                              text=f'<b>Вы уверены, что хотите отправить это сообщение:</b>\n\n{message.text}',
                              reply_markup=confirm_menu())
    await state.update_data(message_text=message.text)
    await MailingMenu.confirm_menu_state.set()


@dp.message_handler(IsPrivate(), IsAdmin(), text='✅Отправить', state=MailingMenu.confirm_menu_state)
async def send_a_message(message: types.message, state: FSMContext):
    message_text = await state.get_data('message_text')
    await dp.bot.send_message(message.from_user.id,
                              text=f'<b>✅Рассылка успешно отправлена</b>')
    await dp.bot.send_message(message.from_user.id, '<b>Выберите кнопку для продолжения</b>', reply_markup=start_menu())
    await send_a_newsletter(message_text['message_text'])
    await AllPages.page_1.set()
