from aiogram.dispatcher.filters.builtin import CommandStart

from filters.all_filters import IsPrivate
from keyboards.inline.channels_inline import links_to_channels
from keyboards.default.admin_keyboard import start_menu
from states.all_states import AllPages
from utils.other_functions import *
from datetime import datetime


@dp.message_handler(IsPrivate(), text='Начать', state='*')
@dp.message_handler(CommandStart(), state='*')
async def bot_start(message: types.message):
    user_name = message.from_user.first_name
    user_login = message.from_user.username
    get_user_id = get_user(user_id=message.from_user.id)
    if get_user_id is None:
        add_user(message.from_user.id, user_login, user_name,
                 datetime.now().strftime("%d.%m.%Y %H:%M:%S"), 0)
    else:
        if user_name != get_user_id['user_name']:
            update_user(get_user_id['user_id'], user_name=user_name)
        if user_login is not None:
            if user_login.lower() != get_user_id['user_login']:
                update_user(get_user_id['user_id'], user_login=user_login.lower())
    flag = await checking_a_channel_subscription(message.from_user.id)
    if flag:
        photo = open('second_bot/images/photo_1.jpg', 'rb')
        await dp.bot.send_photo(message.from_user.id, photo,
                                f"<b>🔥 Поздравляем, Вы встали в очередь на получение премиума! В течении 72 часов с вами свяжется модератор</b>")
    else:
        await dp.bot.send_message(message.from_user.id,
                                  f"<b>⭐Для получения премиума подпишитесь на наших спонсоров, которые помогают нам с раздачей:</b>",
                                  reply_markup=links_to_channels())
    flag_admin = await check_admin(user_id=message.from_user.id)
    if flag_admin:
        await dp.bot.send_message(message.from_user.id, '<b>Выберите кнопку для продолжения</b>', reply_markup=start_menu())
    await AllPages.page_1.set()
