import datetime
from data.config import load_config
from loader import dp
from aiogram import types
from utils.db_api.api_sqlite import *


async def check_admin(user_id):
    config = load_config()
    flag = False
    for admin in config.tg_bot.admin_ids:
        if str(admin) == str(user_id):
            flag = True
    return flag


async def generate_stats():
    users = get_all_users()
    count_all_users = len(users)
    count_users_day = 0
    count_users_week = 0
    count_users_month = 0
    now_time = datetime.datetime.now()
    for user in users:
        registration_date = datetime.datetime.strptime(user['registration_date'], '%d.%m.%Y %H:%M:%S')
        one_day = f'{datetime.datetime.now().strftime("%d.%m.%Y")} 00:00:00'
        one_day = datetime.datetime.strptime(one_day, '%d.%m.%Y %H:%M:%S')
        one_week = datetime.timedelta(7)
        one_month = datetime.timedelta(30)
        if one_day <= registration_date:
            count_users_day += 1
        if now_time - one_week <= registration_date:
            count_users_week += 1
        if now_time - one_month <= registration_date:
            count_users_month += 1
    text_stat = f'💼<b> Меню администратора</b>\n\n' \
                f'👥 Пользователей всего: {count_all_users}\n' \
                f'👤 За месяц: {count_users_month}\n' \
                f'👤 За неделю: {count_users_week}\n' \
                f'👤 За день: {count_users_day}'
    return text_stat


async def send_a_newsletter(text):
    config = load_config()
    users = get_all_users()
    for user in users:
        if user['user_id'] not in config.tg_bot.admin_ids:
            try:
                await dp.bot.send_message(user['user_id'], text=text)
            except:
                pass


async def checking_a_channel_subscription(user_id):
    config = load_config()
    subscribed = 0
    for channel_id in config.tg_bot.channels_ids:
        channel_id = int(str(channel_id).strip())
        sub = await dp.bot.get_chat_member(chat_id=channel_id, user_id=user_id)
        if sub.status != types.ChatMemberStatus.LEFT:
            subscribed += 1
        else:
            break
    if subscribed == len(config.tg_bot.channels_ids):
        return True
    else:
        return False
